
#include <ESP8266WiFi.h>  
#include <SoftwareSerial.h>
SoftwareSerial UnoSerial(D1, D0);
//https://github.com/esp8266/Arduino
#include <SimpleTimer.h>
//needed for library
#include <DNSServer.h>
#include <ESP8266WebServer.h>
#include <WiFiManager.h>         //https://github.com/tzapu/WiFiManager
#define BLYNK_PRINT Serial
#include <BlynkSimpleEsp8266.h>
//int CLOCKWISE = D6;
//int COUNTERCLOCKWISE = D7;

BlynkTimer timer;

#include <BlynkSimpleEsp8266.h>
char auth[] = "Y-tLinr4-emQll2sEOuPHPFp0-2FUiK1";

const int buttonPin = 5;
int buttonstate = 0;
int bc = 50;
int sensitive = 100;
int offset = 2500;
double getCA() {
int count = 200;
double sum = 0;
for (int i = 0; i < count; i++) {
sum += getC();
}
double val = sum / count;
return val;
}
// อ่านค่ากระแส
double getC() {
int a = analogRead(A0);
double v = (a / 1024.0) * 5000;
    double c = (v - offset) / sensitive;
return c;
}
 void setup() {
  // pinMode(D6,OUTPUT);
   //pinMode(D7,OUTPUT);
    pinMode(D1, INPUT);
    pinMode(D0, OUTPUT);
    Serial.begin(9600);
    UnoSerial.begin(9600);
      pinMode(buttonPin,INPUT);
      Serial.println();
      Serial.println("NodeMCU/ESP8266 Run");
      buttonstate = digitalRead(buttonPin);  
   //   timer.setInterval(1000L, sendSensor);
      timer.setInterval(1000L  , voltandrpm);
      

    
    WiFiManager wifiManager;
  
    if (buttonstate == HIGH){
    wifiManager.resetSettings();}
    
    
    wifiManager.autoConnect("AutoConnectAP");
   
   Blynk.config(auth);
    
    
    Serial.println("connected...yeey :)");
}
//void voltage()
 
//{
    
    //float val2 = NodeSerial.parseFloat();
  // if (NodeSerial.read() == '\n')

  // { Blynk.virtualWrite(1, val2);
       
     
    //  delay(1000);}}




  
   BLYNK_CONNECTED() 
   {
     Blynk.syncAll(); 
   }
   
  //BLYNK_WRITE(V2) // control voltage slider
   //{
    
   // int value = param.asInt();
   // Serial.print("supply");
   // Serial.print(" : ");
  //  Serial.println(value);
  //  analogWrite(D4,value);
    
  // } 
//void sendSensor()
//{ double c = getCA();  
 //erial.print("  current = ");
     //   Serial.print(c);
      //  Serial.println();
//}



void voltandrpm() //show ค่าแรงดัน กระแส ความเร็วรอบ
{
   static int state = 0;
  static int index = 0;
  static char Buffer[4];
  static int  val1;
  float  val2;  
double c = getCA();  

  
 
  if(UnoSerial.available() > 0)
  { 
    
    char data = UnoSerial.read();
    switch(state){
      case 0: if(data == '#'){
        index = 0;
        state = 1;
        
      }
      break;
      
      case 1: if(data == ':'){
        
        Buffer[index] = '\0';
        val1 = atoi(Buffer);
        state = 2;
        index = 0;
        
      }else{
        Buffer[index] = data;
        index++;
        
      }
      break;

       case 2: if(data == ';'){
        Buffer[index] = '\0'; 
        val2 = atoi(Buffer);
        state = 0;
         Serial.print("RPM =");
         Serial.print(val1);
         Serial.print("  Voltage =");
         Serial.print(val2);
        Serial.print("  current = ");
        Serial.print(c);
        Serial.println();
        
        //show on blynk
        Blynk.virtualWrite(0, c);    //current
        Blynk.virtualWrite(1, val2); //voltage
        Blynk.virtualWrite(3, val1); //rpm
      }else{
        Buffer[index] = data;
        index++;
        
      }
      break;
    }
  }
}

  
void loop() { 
  voltandrpm();
  delay(1000);
      
  
    

        
        

    Blynk.run();
    timer.run();
    
   

    
    
    
}


  
